// Autogenerated from Pigeon (v3.0.3), do not edit directly.
// See also: https://pub.dev/packages/pigeon
#import "PushApi.h"
#import <Flutter/Flutter.h>

#if !__has_feature(objc_arc)
#error File requires ARC to be enabled.
#endif

static NSDictionary<NSString *, id> *wrapResult(id result, FlutterError *error) {
  NSDictionary *errorDict = (NSDictionary *)[NSNull null];
  if (error) {
    errorDict = @{
        @"code": (error.code ? error.code : [NSNull null]),
        @"message": (error.message ? error.message : [NSNull null]),
        @"details": (error.details ? error.details : [NSNull null]),
        };
  }
  return @{
      @"result": (result ? result : [NSNull null]),
      @"error": errorDict,
      };
}
static id GetNullableObject(NSDictionary* dict, id key) {
  id result = dict[key];
  return (result == [NSNull null]) ? nil : result;
}
static id GetNullableObjectAtIndex(NSArray* array, NSInteger key) {
  id result = array[key];
  return (result == [NSNull null]) ? nil : result;
}


@interface PURemoteMessage ()
+ (PURemoteMessage *)fromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end
@interface PUNotification ()
+ (PUNotification *)fromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end
@interface PUUNNotificationSettings ()
+ (PUUNNotificationSettings *)fromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end

@implementation PURemoteMessage
+ (instancetype)makeWithNotification:(nullable PUNotification *)notification
    data:(nullable NSDictionary<NSString *, id> *)data {
  PURemoteMessage* pigeonResult = [[PURemoteMessage alloc] init];
  pigeonResult.notification = notification;
  pigeonResult.data = data;
  return pigeonResult;
}
+ (PURemoteMessage *)fromMap:(NSDictionary *)dict {
  PURemoteMessage *pigeonResult = [[PURemoteMessage alloc] init];
  pigeonResult.notification = [PUNotification fromMap:GetNullableObject(dict, @"notification")];
  pigeonResult.data = GetNullableObject(dict, @"data");
  return pigeonResult;
}
- (NSDictionary *)toMap {
  return [NSDictionary dictionaryWithObjectsAndKeys:(self.notification ? [self.notification toMap] : [NSNull null]), @"notification", (self.data ? self.data : [NSNull null]), @"data", nil];
}
@end

@implementation PUNotification
+ (instancetype)makeWithTitle:(nullable NSString *)title
    body:(nullable NSString *)body {
  PUNotification* pigeonResult = [[PUNotification alloc] init];
  pigeonResult.title = title;
  pigeonResult.body = body;
  return pigeonResult;
}
+ (PUNotification *)fromMap:(NSDictionary *)dict {
  PUNotification *pigeonResult = [[PUNotification alloc] init];
  pigeonResult.title = GetNullableObject(dict, @"title");
  pigeonResult.body = GetNullableObject(dict, @"body");
  return pigeonResult;
}
- (NSDictionary *)toMap {
  return [NSDictionary dictionaryWithObjectsAndKeys:(self.title ? self.title : [NSNull null]), @"title", (self.body ? self.body : [NSNull null]), @"body", nil];
}
@end

@implementation PUUNNotificationSettings
+ (instancetype)makeWithAuthorizationStatus:(PUUNAuthorizationStatus)authorizationStatus
    soundSetting:(PUUNNotificationSetting)soundSetting
    badgeSetting:(PUUNNotificationSetting)badgeSetting
    alertSetting:(PUUNNotificationSetting)alertSetting
    notificationCenterSetting:(PUUNNotificationSetting)notificationCenterSetting
    lockScreenSetting:(PUUNNotificationSetting)lockScreenSetting
    carPlaySetting:(PUUNNotificationSetting)carPlaySetting
    alertStyle:(PUUNAlertStyle)alertStyle
    showPreviewsSetting:(PUUNShowPreviewsSetting)showPreviewsSetting
    criticalAlertSetting:(PUUNNotificationSetting)criticalAlertSetting
    providesAppNotificationSettings:(nullable NSNumber *)providesAppNotificationSettings
    announcementSetting:(PUUNNotificationSetting)announcementSetting {
  PUUNNotificationSettings* pigeonResult = [[PUUNNotificationSettings alloc] init];
  pigeonResult.authorizationStatus = authorizationStatus;
  pigeonResult.soundSetting = soundSetting;
  pigeonResult.badgeSetting = badgeSetting;
  pigeonResult.alertSetting = alertSetting;
  pigeonResult.notificationCenterSetting = notificationCenterSetting;
  pigeonResult.lockScreenSetting = lockScreenSetting;
  pigeonResult.carPlaySetting = carPlaySetting;
  pigeonResult.alertStyle = alertStyle;
  pigeonResult.showPreviewsSetting = showPreviewsSetting;
  pigeonResult.criticalAlertSetting = criticalAlertSetting;
  pigeonResult.providesAppNotificationSettings = providesAppNotificationSettings;
  pigeonResult.announcementSetting = announcementSetting;
  return pigeonResult;
}
+ (PUUNNotificationSettings *)fromMap:(NSDictionary *)dict {
  PUUNNotificationSettings *pigeonResult = [[PUUNNotificationSettings alloc] init];
  pigeonResult.authorizationStatus = [GetNullableObject(dict, @"authorizationStatus") integerValue];
  pigeonResult.soundSetting = [GetNullableObject(dict, @"soundSetting") integerValue];
  pigeonResult.badgeSetting = [GetNullableObject(dict, @"badgeSetting") integerValue];
  pigeonResult.alertSetting = [GetNullableObject(dict, @"alertSetting") integerValue];
  pigeonResult.notificationCenterSetting = [GetNullableObject(dict, @"notificationCenterSetting") integerValue];
  pigeonResult.lockScreenSetting = [GetNullableObject(dict, @"lockScreenSetting") integerValue];
  pigeonResult.carPlaySetting = [GetNullableObject(dict, @"carPlaySetting") integerValue];
  pigeonResult.alertStyle = [GetNullableObject(dict, @"alertStyle") integerValue];
  pigeonResult.showPreviewsSetting = [GetNullableObject(dict, @"showPreviewsSetting") integerValue];
  pigeonResult.criticalAlertSetting = [GetNullableObject(dict, @"criticalAlertSetting") integerValue];
  pigeonResult.providesAppNotificationSettings = GetNullableObject(dict, @"providesAppNotificationSettings");
  pigeonResult.announcementSetting = [GetNullableObject(dict, @"announcementSetting") integerValue];
  return pigeonResult;
}
- (NSDictionary *)toMap {
  return [NSDictionary dictionaryWithObjectsAndKeys:@(self.authorizationStatus), @"authorizationStatus", @(self.soundSetting), @"soundSetting", @(self.badgeSetting), @"badgeSetting", @(self.alertSetting), @"alertSetting", @(self.notificationCenterSetting), @"notificationCenterSetting", @(self.lockScreenSetting), @"lockScreenSetting", @(self.carPlaySetting), @"carPlaySetting", @(self.alertStyle), @"alertStyle", @(self.showPreviewsSetting), @"showPreviewsSetting", @(self.criticalAlertSetting), @"criticalAlertSetting", (self.providesAppNotificationSettings ? self.providesAppNotificationSettings : [NSNull null]), @"providesAppNotificationSettings", @(self.announcementSetting), @"announcementSetting", nil];
}
@end

@interface PUPushHostApiCodecReader : FlutterStandardReader
@end
@implementation PUPushHostApiCodecReader
- (nullable id)readValueOfType:(UInt8)type 
{
  switch (type) {
    case 128:     
      return [PUNotification fromMap:[self readValue]];
    
    case 129:     
      return [PURemoteMessage fromMap:[self readValue]];
    
    case 130:     
      return [PUUNNotificationSettings fromMap:[self readValue]];
    
    default:    
      return [super readValueOfType:type];
    
  }
}
@end

@interface PUPushHostApiCodecWriter : FlutterStandardWriter
@end
@implementation PUPushHostApiCodecWriter
- (void)writeValue:(id)value 
{
  if ([value isKindOfClass:[PUNotification class]]) {
    [self writeByte:128];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[PURemoteMessage class]]) {
    [self writeByte:129];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[PUUNNotificationSettings class]]) {
    [self writeByte:130];
    [self writeValue:[value toMap]];
  } else 
{
    [super writeValue:value];
  }
}
@end

@interface PUPushHostApiCodecReaderWriter : FlutterStandardReaderWriter
@end
@implementation PUPushHostApiCodecReaderWriter
- (FlutterStandardWriter *)writerWithData:(NSMutableData *)data {
  return [[PUPushHostApiCodecWriter alloc] initWithData:data];
}
- (FlutterStandardReader *)readerWithData:(NSData *)data {
  return [[PUPushHostApiCodecReader alloc] initWithData:data];
}
@end

NSObject<FlutterMessageCodec> *PUPushHostApiGetCodec() {
  static dispatch_once_t sPred = 0;
  static FlutterStandardMessageCodec *sSharedObject = nil;
  dispatch_once(&sPred, ^{
    PUPushHostApiCodecReaderWriter *readerWriter = [[PUPushHostApiCodecReaderWriter alloc] init];
    sSharedObject = [FlutterStandardMessageCodec codecWithReaderWriter:readerWriter];
  });
  return sSharedObject;
}


void PUPushHostApiSetup(id<FlutterBinaryMessenger> binaryMessenger, NSObject<PUPushHostApi> *api) {
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.PushHostApi.getNotificationTapWhichLaunchedTerminatedApp"
        binaryMessenger:binaryMessenger
        codec:PUPushHostApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(getNotificationTapWhichLaunchedTerminatedAppWithError:)], @"PUPushHostApi api (%@) doesn't respond to @selector(getNotificationTapWhichLaunchedTerminatedAppWithError:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        FlutterError *error;
        NSDictionary<NSString *, id> *output = [api getNotificationTapWhichLaunchedTerminatedAppWithError:&error];
        callback(wrapResult(output, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.PushHostApi.getToken"
        binaryMessenger:binaryMessenger
        codec:PUPushHostApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(getTokenWithCompletion:)], @"PUPushHostApi api (%@) doesn't respond to @selector(getTokenWithCompletion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        [api getTokenWithCompletion:^(NSString *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.PushHostApi.backgroundFlutterApplicationReady"
        binaryMessenger:binaryMessenger
        codec:PUPushHostApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(backgroundFlutterApplicationReadyWithError:)], @"PUPushHostApi api (%@) doesn't respond to @selector(backgroundFlutterApplicationReadyWithError:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        FlutterError *error;
        [api backgroundFlutterApplicationReadyWithError:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.PushHostApi.onListenToOnNewToken"
        binaryMessenger:binaryMessenger
        codec:PUPushHostApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(onListenToOnNewTokenWithError:)], @"PUPushHostApi api (%@) doesn't respond to @selector(onListenToOnNewTokenWithError:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        FlutterError *error;
        [api onListenToOnNewTokenWithError:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.PushHostApi.onCancelToOnNewToken"
        binaryMessenger:binaryMessenger
        codec:PUPushHostApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(onCancelToOnNewTokenWithError:)], @"PUPushHostApi api (%@) doesn't respond to @selector(onCancelToOnNewTokenWithError:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        FlutterError *error;
        [api onCancelToOnNewTokenWithError:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.PushHostApi.requestPermission"
        binaryMessenger:binaryMessenger
        codec:PUPushHostApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(requestPermissionBadge:sound:alert:carPlay:criticalAlert:provisional:providesAppNotificationSettings:announcement:completion:)], @"PUPushHostApi api (%@) doesn't respond to @selector(requestPermissionBadge:sound:alert:carPlay:criticalAlert:provisional:providesAppNotificationSettings:announcement:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSNumber *arg_badge = GetNullableObjectAtIndex(args, 0);
        NSNumber *arg_sound = GetNullableObjectAtIndex(args, 1);
        NSNumber *arg_alert = GetNullableObjectAtIndex(args, 2);
        NSNumber *arg_carPlay = GetNullableObjectAtIndex(args, 3);
        NSNumber *arg_criticalAlert = GetNullableObjectAtIndex(args, 4);
        NSNumber *arg_provisional = GetNullableObjectAtIndex(args, 5);
        NSNumber *arg_providesAppNotificationSettings = GetNullableObjectAtIndex(args, 6);
        NSNumber *arg_announcement = GetNullableObjectAtIndex(args, 7);
        [api requestPermissionBadge:arg_badge sound:arg_sound alert:arg_alert carPlay:arg_carPlay criticalAlert:arg_criticalAlert provisional:arg_provisional providesAppNotificationSettings:arg_providesAppNotificationSettings announcement:arg_announcement completion:^(NSNumber *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.PushHostApi.getNotificationSettings"
        binaryMessenger:binaryMessenger
        codec:PUPushHostApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(getNotificationSettingsWithCompletion:)], @"PUPushHostApi api (%@) doesn't respond to @selector(getNotificationSettingsWithCompletion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        [api getNotificationSettingsWithCompletion:^(PUUNNotificationSettings *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
}
@interface PUPushFlutterApiCodecReader : FlutterStandardReader
@end
@implementation PUPushFlutterApiCodecReader
- (nullable id)readValueOfType:(UInt8)type 
{
  switch (type) {
    case 128:     
      return [PUNotification fromMap:[self readValue]];
    
    case 129:     
      return [PURemoteMessage fromMap:[self readValue]];
    
    case 130:     
      return [PUUNNotificationSettings fromMap:[self readValue]];
    
    default:    
      return [super readValueOfType:type];
    
  }
}
@end

@interface PUPushFlutterApiCodecWriter : FlutterStandardWriter
@end
@implementation PUPushFlutterApiCodecWriter
- (void)writeValue:(id)value 
{
  if ([value isKindOfClass:[PUNotification class]]) {
    [self writeByte:128];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[PURemoteMessage class]]) {
    [self writeByte:129];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[PUUNNotificationSettings class]]) {
    [self writeByte:130];
    [self writeValue:[value toMap]];
  } else 
{
    [super writeValue:value];
  }
}
@end

@interface PUPushFlutterApiCodecReaderWriter : FlutterStandardReaderWriter
@end
@implementation PUPushFlutterApiCodecReaderWriter
- (FlutterStandardWriter *)writerWithData:(NSMutableData *)data {
  return [[PUPushFlutterApiCodecWriter alloc] initWithData:data];
}
- (FlutterStandardReader *)readerWithData:(NSData *)data {
  return [[PUPushFlutterApiCodecReader alloc] initWithData:data];
}
@end

NSObject<FlutterMessageCodec> *PUPushFlutterApiGetCodec() {
  static dispatch_once_t sPred = 0;
  static FlutterStandardMessageCodec *sSharedObject = nil;
  dispatch_once(&sPred, ^{
    PUPushFlutterApiCodecReaderWriter *readerWriter = [[PUPushFlutterApiCodecReaderWriter alloc] init];
    sSharedObject = [FlutterStandardMessageCodec codecWithReaderWriter:readerWriter];
  });
  return sSharedObject;
}


@interface PUPushFlutterApi ()
@property (nonatomic, strong) NSObject<FlutterBinaryMessenger> *binaryMessenger;
@end

@implementation PUPushFlutterApi

- (instancetype)initWithBinaryMessenger:(NSObject<FlutterBinaryMessenger> *)binaryMessenger {
  self = [super init];
  if (self) {
    _binaryMessenger = binaryMessenger;
  }
  return self;
}
- (void)onMessageMessage:(PURemoteMessage *)arg_message completion:(void(^)(NSError *_Nullable))completion {
  FlutterBasicMessageChannel *channel =
    [FlutterBasicMessageChannel
      messageChannelWithName:@"dev.flutter.pigeon.PushFlutterApi.onMessage"
      binaryMessenger:self.binaryMessenger
      codec:PUPushFlutterApiGetCodec()];
  [channel sendMessage:@[(arg_message == nil) ? [NSNull null] : arg_message] reply:^(id reply) {
    completion(nil);
  }];
}
- (void)onBackgroundMessageMessage:(PURemoteMessage *)arg_message completion:(void(^)(NSError *_Nullable))completion {
  FlutterBasicMessageChannel *channel =
    [FlutterBasicMessageChannel
      messageChannelWithName:@"dev.flutter.pigeon.PushFlutterApi.onBackgroundMessage"
      binaryMessenger:self.binaryMessenger
      codec:PUPushFlutterApiGetCodec()];
  [channel sendMessage:@[(arg_message == nil) ? [NSNull null] : arg_message] reply:^(id reply) {
    completion(nil);
  }];
}
- (void)onNotificationTapData:(NSDictionary<NSString *, id> *)arg_data completion:(void(^)(NSError *_Nullable))completion {
  FlutterBasicMessageChannel *channel =
    [FlutterBasicMessageChannel
      messageChannelWithName:@"dev.flutter.pigeon.PushFlutterApi.onNotificationTap"
      binaryMessenger:self.binaryMessenger
      codec:PUPushFlutterApiGetCodec()];
  [channel sendMessage:@[(arg_data == nil) ? [NSNull null] : arg_data] reply:^(id reply) {
    completion(nil);
  }];
}
- (void)onNewTokenToken:(NSString *)arg_token completion:(void(^)(NSError *_Nullable))completion {
  FlutterBasicMessageChannel *channel =
    [FlutterBasicMessageChannel
      messageChannelWithName:@"dev.flutter.pigeon.PushFlutterApi.onNewToken"
      binaryMessenger:self.binaryMessenger
      codec:PUPushFlutterApiGetCodec()];
  [channel sendMessage:@[(arg_token == nil) ? [NSNull null] : arg_token] reply:^(id reply) {
    completion(nil);
  }];
}
- (void)onOpenNotificationSettingsWithCompletion:(void(^)(NSError *_Nullable))completion {
  FlutterBasicMessageChannel *channel =
    [FlutterBasicMessageChannel
      messageChannelWithName:@"dev.flutter.pigeon.PushFlutterApi.onOpenNotificationSettings"
      binaryMessenger:self.binaryMessenger
      codec:PUPushFlutterApiGetCodec()];
  [channel sendMessage:nil reply:^(id reply) {
    completion(nil);
  }];
}
@end
